<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Directory"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
	final ItemContext cc = sc.getCurrentContext(Item.DIRECTORY);
	final List<Directory> recentDirectories = (List<Directory>)cc.getRecent(dc, Item.DIRECTORY, "reggie");
	Directory currentDirectory = null;
	try
	{
		if (cc.getId() != 0) currentDirectory = Directory.getById(dc, cc.getId());
	}
	catch (Exception ex)
	{}
	//final List<Directory> recentDirectories = Directory.getQuery().list(dc);
%>
<base:page type="default" >
<base:head scripts="ajax.js" styles="path.css">
	<link rel="stylesheet" type="text/css" href="reggie.css">
	<script language="JavaScript" src="reggie.js" type="text/javascript" charset="UTF-8"></script>

<script language="JavaScript">

var debug = false;
var currentStep = 1;

function init()
{
	var frm = document.forms['reggie'];
}

function step1IsValid()
{
	var frm = document.forms['reggie'];
	var list = frm.directoryId;
	if (list.selectedIndex < 0 || list[list.selectedIndex].value == '0')
	{
		setInputStatus('directory', 'Required', 'invalid');
		return false;
	}
	setInputStatus('directory', '', 'valid');
	return true;
}

function selectDirectoryOnClick()
{
	if (currentStep != 1) return;
	var frm = document.forms['reggie'];
	if (frm.directoryId.disabled) return;
	var url = '../../filemanager/directories/index.jsp?ID=<%=ID%>&mode=selectonedirectory&callback=setDirectoryCallback';
	if (frm.directoryId.length > 0) 
	{
		var id = Math.abs(parseInt(frm.directoryId[0].value));
		url += '&directory_id='+id;
	}
	Main.openPopup(url, 'SelectDirectory', 350, 500);
}
function setDirectoryCallback(id, name)
{
	var frm = document.forms['reggie'];
	var list = frm.directoryId;
	if (list.length < 1 || list[0].value == '0') // >
	{
		Forms.addListOption(list, 0, new Option());
	}
	list[0].value = id;
	list[0].text = name;
	list.selectedIndex = 0;
}

function goProcess()
{
	if (!step1IsValid()) return;

	Main.hide('gocancel');
	Main.hide('goprocess');
	
	var frm = document.forms['reggie'];
	
	frm.directoryId.disabled = true;
	frm.pattern.disabled = true;
	Main.addClass(document.getElementById('directoryId'), 'disabled');
	
	var directoryId = frm.directoryId.value;
	var pattern = frm.pattern.value;
	var request = Ajax.getXmlHttpRequest();
	var url = 'ReferralForm.servlet?ID=<%=ID%>&cmd=ScanDirectory';
	url += '&directoryId=' + directoryId;
	url += '&pattern=' + encodeURIComponent(pattern);
	request.open("GET", url, false); 
	request.send(null);
	
	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	
	currentStep = 2;
	var files = response.files;
	
	setInnerHTML('step2.title', 'Processed ' + files.length + ' file(s)');
	
	var numAlreadyLinked = 0;
	var numLinkedNow = 0;
	var numNotLinked = 0;
	
	var htmlAlreadyLinked = '';
	var htmlLinkedNow = '';
	var htmlNotLinked = '';
	
	// Collect information
	for (var i = 0; i < files.length; i++)
	{
		var file = files[i];
		
		if (file.link)
		{
			numAlreadyLinked++;
			htmlAlreadyLinked += '<tr><td class="file">'+file.name+'</td><td>Link existed to case '+file.caseInfo.name+'</td>\n';
		}
		else if (file.caseInfo)
		{
			numLinkedNow++;
			htmlLinkedNow += '<tr><td class="file">'+file.name+'</td><td>Link created to case '+file.caseInfo.name+'</td>\n';
		}
		else
		{
			numNotLinked++;
			htmlNotLinked += '<tr><td class="file">'+file.name+'</td><td>'+file.message+'</td>\n';
		}
		
		var html = '<table class="linktable">';
		if (numAlreadyLinked > 0)
		{
			html += '<tr><td colspan="2" class="summary" onclick="showHide(\'alreadyLinked\')" title="Click to show/hide details">';
			html += '<img src="../../images/show_section.gif" id="alreadyLinkedImg">';
			html += numAlreadyLinked + ' file(s) was already linked to a case</td></tr>\n';
			html += '<tbody id="alreadyLinked" style="display: none;">' + htmlAlreadyLinked + "</tbody>";
		}
		if (numLinkedNow > 0)
		{
			html += '<tr><td colspan="2" class="summary" onclick="showHide(\'linkCreated\')" title="Click to show/hide details">';
			html += '<img src="../../images/hide_section.gif" id="linkCreatedImg">';
			html += numLinkedNow + ' file(s) linked to a case</td></tr>\n';
			html += '<tbody id="linkCreated">' + htmlLinkedNow + "</tbody>";
		}
		if (numNotLinked > 0)
		{
			html += '<tr><td colspan="2" class="summary" onclick="showHide(\'notLinked\')" title="Click to show/hide details">';
			html += '<img src="../../images/hide_section.gif" id="notLinkedImg">';
			html += numNotLinked + ' file(s) could not be linked</td></tr>\n';
			html += '<tbody id="notLinked">' + htmlNotLinked + "</tbody>";
		}
		
		setInnerHTML('filesProcessed', html);
	}
	Main.show('filesSection');
	Main.show('gorestart');
}

function showHide(sectionId)
{
	Main.showHide(sectionId);	
	var img = document.getElementById(sectionId + 'Img');
	img.src = img.src.indexOf('show') > 0 ? '../../images/hide_section.gif' : '../../images/show_section.gif';
}
</script>
<style>
.stepfields select
{
	width: 15em;
}

.disabled .buttonclass_inner 
{
	color: #666666;
}

.disabled .buttonclass_hover 
{
	color: #666666;
	background: #E0E0E0;
	cursor: default;
}

.linktable
{
	width: 100%;
}

.linktable .summary
{
	font-weight: bold;
	color: #333377;
	border-bottom: 1px solid #999999;
	cursor: pointer;
}

.linktable .file
{
	padding-left: 12px;
	width: 120px;
}
</style>
</base:head>
<base:body onload="init()">

	<p:path style="margin-top: 20px; margin-bottom: 10px;">
		<p:pathelement title="Reggie" href="<%="index.jsp?ID="+ID%>" />
		<p:pathelement title="Referral form registration" />
	</p:path>

	<%
	if (sc.getActiveProjectId() == 0)
	{
		%>
		<base:note type="warning" style="width: 800px; margin-left: 20px; margin-bottom: 20px; margin-right: 0px; font-weight: bold; color: #cc0000;">
			No project has been selected. You may proceed with the registration but 
			created items will not be shared.
		</base:note>
		<%
	}
	%>

	<form name="reggie" onsubmit="return false;">
	
	<!-- 1. Dirtory with files + filename pattern -->
	<table border="0" cellspacing="0" cellpadding="0" class="stepform">
	<tr>
		<td rowspan="3" class="stepno">1</td>
		<td class="steptitle">Select directory and filename pattern</td>
	</tr>
	<tr>
		<td class="stepfields">
			<table border="0" cellspacing="0" cellpadding="0" width="100%">
			<tr valign="top">
				<td class="prompt">Directory</td>
				<td class="input">
					<base:select 
						id="directoryId"
						clazz="selectionlist"
						current="<%=currentDirectory%>"
						required="true"
						recent="<%=recentDirectories%>"
						newitem="true"
						onselect="selectDirectoryOnClick()"
					/>
				</td>
				<td class="status" id="directory.status"></td>
				<td class="help"><span id="directory.message" class="message" style="display: none;"></span>
					The directory containing scanned referral forms. Sub-directories are not searched.</td>
			</tr>
			<tr>
				<td class="prompt">Filename pattern</td>
				<td class="input"><input type="text" name="pattern" 
					size="18" maxlength="12" value="%.pdf"></td>
				<td class="status" id="pattern.status"></td>
				<td class="help"><span id="pattern.message" class="message" style="display: none;"></span>Use % as wildcard. If empty all files will be used.</td>
			</tr>
			</table>
		</td>
	</tr>
	</table>

	<div id="filesSection" style="display: none;">
	<p>
	<table border="0" cellspacing="0" cellpadding="0" class="stepform">
	<tr>
		<td rowspan="2" class="stepno">2</td>
		<td class="steptitle" id="step2.title">Processed x files</td>
	</tr>
	<tr>
		<td class="stepfields" id="filesProcessed">

		</td>
	</tr>
	</table>
	</div>

	<div class="error" id="errorMessage" style="display: none; width: 800px; margin-left: 20px; margin-bottom: 0px;"></div>

	<div id="done" class="success" style="display: none; width: 800px; margin-left: 20px; margin-top: 20px;"></div>

	<table style="margin-left: 20px; margin-top: 10px;" class="navigation">
	<tr>
		<td><base:button id="gocancel" title="Cancel" onclick="goRestart(false)" style="display: none;"/></td>
		<td><base:button id="goprocess" title="Process" image="gonext.gif" onclick="goProcess()" 
			tooltip="Process the files in the selected directory"/></td>
		<td><base:button id="gorestart" title="Restart" image="goback.gif" onclick="goRestart(true)" style="display: none;"/></td>
		<td id="gonext.message" class="message"></td>
	</tr>
	</table>
	</form>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>